"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const MessageHandler_1 = require("../lib/MessageHandler");
const assert = __importStar(require("assert"));
const helper_1 = require("./helper");
function assertHover(position, expected, fixturePath) {
    const textDocument = (0, helper_1.getTextDocument)(fixturePath);
    const params = {
        textDocument,
        position: position,
    };
    const hoverResult = (0, MessageHandler_1.handleHoverRequest)(textDocument, params);
    assert.ok(hoverResult !== undefined);
    assert.deepStrictEqual(hoverResult.contents, expected.contents);
    assert.deepStrictEqual(hoverResult.range, expected.range);
}
suite('Hover of /// documentation comments', () => {
    const fixturePath = './hover_postgresql.prisma';
    test('Model', () => {
        assertHover({
            character: 15,
            line: 24,
        }, {
            contents: "Post including an author, it's content\n\nand whether it was published",
        }, fixturePath);
    });
    test('Enum', () => {
        assertHover({
            character: 15,
            line: 25,
        }, {
            contents: 'This is an enum specifying the UserName.',
        }, fixturePath);
    });
});
//# sourceMappingURL=hover.test.js.map