import { DocumentFormattingParams, TextEdit, DeclarationParams, CompletionParams, CompletionList, CompletionItem, HoverParams, Hover, CodeActionParams, CodeAction, Diagnostic, RenameParams, WorkspaceEdit, DocumentSymbolParams, DocumentSymbol, LocationLink } from 'vscode-languageserver';
import type { TextDocument } from 'vscode-languageserver-textdocument';
export declare function handleDiagnosticsRequest(document: TextDocument, onError?: (errorMessage: string) => void): Diagnostic[];
/**
 * @todo Use official schema.prisma parser. This is a workaround!
 */
export declare function handleDefinitionRequest(document: TextDocument, params: DeclarationParams): LocationLink[] | undefined;
/**
 * This handler provides the modification to the document to be formatted.
 */
export declare function handleDocumentFormatting(params: DocumentFormattingParams, document: TextDocument, onError?: (errorMessage: string) => void): TextEdit[];
export declare function handleHoverRequest(document: TextDocument, params: HoverParams): Hover | undefined;
/**
 *
 * This handler provides the initial list of the completion items.
 */
export declare function handleCompletionRequest(params: CompletionParams, document: TextDocument, onError?: (errorMessage: string) => void): CompletionList | undefined;
export declare function handleRenameRequest(params: RenameParams, document: TextDocument): WorkspaceEdit | undefined;
/**
 *
 * @param item This handler resolves additional information for the item selected in the completion list.
 */
export declare function handleCompletionResolveRequest(item: CompletionItem): CompletionItem;
export declare function handleCodeActions(params: CodeActionParams, document: TextDocument, onError?: (errorMessage: string) => void): CodeAction[];
export declare function handleDocumentSymbol(params: DocumentSymbolParams, document: TextDocument): DocumentSymbol[];
