import { CompletionItem, CompletionList } from 'vscode-languageserver';
import type { TextDocument } from 'vscode-languageserver-textdocument';
import { Block } from '../ast';
/**
 * * Only models and views currently support block attributes
 */
export declare function getSuggestionForBlockAttribute(block: Block, lines: string[]): CompletionItem[];
/**
 * Should suggest all field attributes for a given field
 * EX: id Int |> @id, @default, @datasourceName, ...etc
 *
 * If `@datasourceName.` |> suggests nativeTypes
 * @param block
 * @param currentLine
 * @param lines
 * @param wordsBeforePosition
 * @param document
 * @returns
 */
export declare function getSuggestionForFieldAttribute(block: Block, currentLine: string, lines: string[], wordsBeforePosition: string[], document: TextDocument, onError?: (errorMessage: string) => void): CompletionList | undefined;
