"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = require(".");
const internals_1 = require("./internals");
function format(schema, options, onError) {
    console.log('running format() from prisma-schema-wasm');
    try {
        if (process.env.FORCE_PANIC_PRISMA_SCHEMA) {
            (0, internals_1.handleFormatPanic)(() => {
                console.debug('Triggering a Rust panic...');
                _1.prismaSchemaWasm.debug_panic();
            });
        }
        return _1.prismaSchemaWasm.format(schema, JSON.stringify(options));
    }
    catch (e) {
        const err = e;
        console.warn('\nprisma-schema-wasm errored during formatting. Please report this issue on [Prisma Language Tools](https://github.com/prisma/language-tools/issues). \nLinter output:\n');
        (0, internals_1.handleWasmError)(err, 'format', onError);
        return schema;
    }
}
exports.default = format;
//# sourceMappingURL=format.js.map