"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = require(".");
const internals_1 = require("./internals");
function lint(text, onError) {
    console.log('running lint() from prisma-schema-wasm');
    try {
        if (process.env.FORCE_PANIC_PRISMA_SCHEMA) {
            (0, internals_1.handleFormatPanic)(() => {
                console.debug('Triggering a Rust panic...');
                _1.prismaSchemaWasm.debug_panic();
            });
        }
        const result = _1.prismaSchemaWasm.lint(text);
        return JSON.parse(result);
    }
    catch (e) {
        const err = e;
        (0, internals_1.handleWasmError)(err, 'lint', onError);
        return [];
    }
}
exports.default = lint;
//# sourceMappingURL=lint.js.map